(()=>{
    "use strict";
    return {
        dependencies: ["packages://inspector/share/meta-header.js", "packages://inspector/share/audio-preview.js"],
        template: `
              <cc-meta-header
                :target="target"
                icon="unpack://static/icon/assets/audio-clip.png"
              ></cc-meta-header>

              <div class="props flex-1">
                <ui-prop :name="T('INSPECTOR.audio.download_mode')" type="Enum"
                  v-value="target.downloadMode"
                  v-values="target.multiValues.downloadMode"
                  :multi-values="multi"
                >
                    <option value="0">Web Audio</option>
                    <option value="1">DOM Audio</option>
                </ui-prop>
              </div>

              <cc-audio-preview :target="target" v-ref:preview v-if="!multi">
              </cc-audio-preview>
            `,
        methods: {
            resize() {
                this.$refs.preview.resize()
            }
        }
    }
}
)();
