"use strict";
Vue.component("cc-widget", {
    dependencies: ["packages://inspector/share/alignment-preview.js"],
    template: `

    <style>
      #widget-outer {
            width: 200px;
            margin: 0 auto;
      }
      #upper {
            margin: 0 auto 6px auto;
      }
      #lower {
            margin-left: 6px;
      }
      #widget-outer .h-control-group {
            height: 26px;
            position: relative;
            margin-left: 72px;
      }
      #widget-outer .v-control-group {
            width: 47px;
            height: 39px;
      }
      #widget-outer .top-input {
            position: relative;
            margin-left: 18px
      }
      #widget-outer .bottom-input {
            margin-top: 4px;
      }
      #widget-outer .right-input {
            position: relative;
      }
      /*.bottom-input::shadow input {*/
        /*vertical-align: text-bottom;*/
        /*padding: 0.2em 0.4em;*/
      /*}*/
      /*.right-input::shadow input {*/
        /*vertical-align: text-bottom;*/
        /*padding: 0.2em 0.4em;*/
      /*}*/
      #widget-outer .v-checkbox {
            margin: 0px;
      }
      #widget-outer .centered-prop {
            height: 25px;
      }
      #widget-outer ui-input {
            width: 5.4em;
            margin: 0px;
      }
      #widget-outer hr {
            margin-top: 5px;
            margin-bottom: 5px;
      }
    </style>

    <div id="widget-outer">
      <div id="upper">
        <div class="h-control-group layout horizontal center">
          <ui-checkbox
            v-value="target.isAlignTop.value"
            v-values="target.isAlignTop.values"
            :multi-values="_checkWidgetMulti(target.isAlignTop)"
            @change="_onTopBottomChecked"
            :title="T('COMPONENT.widget.align_top')"
          >Top</ui-checkbox>
          <ui-input class="top-input small"
            v-value="topValue"

            @confirm="_onTopChanged"
            :title="T('COMPONENT.widget.top')"
            v-show="_checkWidgetInput(target.isAlignTop, multi)"
          ></ui-input>
        </div>

        <div class="layout horizontal center">
          <div class="v-control-group layout vertical end">
            <ui-checkbox class="v-checkbox"
              v-value="target.isAlignLeft.value"
              v-values="target.isAlignLeft.values"
              :multi-values="_checkWidgetMulti(target.isAlignLeft)"
              @change="_onLeftRightChecked"
              :title="T('COMPONENT.widget.align_left')"
            >Left</ui-checkbox>
            <ui-input class="bottom-input small"
              :value="leftValue"
              @confirm="_onLeftChanged"
              :title="T('COMPONENT.widget.left')"
              v-show="_checkWidgetInput(target.isAlignLeft, multi)"
            ></ui-input>
          </div>

          <cc-alignment-preview :target.sync="target"></cc-alignment-preview>

          <div class="v-control-group layout vertical">
            <ui-checkbox class="v-checkbox"
              v-value="target.isAlignRight.value"
              v-values="target.isAlignRight.values"
              :multi-values="_checkWidgetMulti(target.isAlignRight)"
              @change="_onLeftRightChecked"
              :title="T('COMPONENT.widget.align_right')"
            >Right</ui-checkbox>
            <ui-input class="bottom-input small"
              :value="rightValue"
              @confirm="_onRightChanged"
              :title="T('COMPONENT.widget.right')"
              v-show="_checkWidgetInput(target.isAlignRight, multi)"
            ></ui-input>
          </div>
        </div>

        <div class="h-control-group layout horizontal center">
          <ui-checkbox class="h-checkbox"
            v-value="target.isAlignBottom.value"
            v-values="target.isAlignBottom.values"
            :multi-values="_checkWidgetMulti(target.isAlignBottom)"
            @change="_onTopBottomChecked"
            :title="T('COMPONENT.widget.align_bottom')"
          >Bottom</ui-checkbox>
          <ui-input class="right-input small"
            :value="bottomValue"
            @confirm="_onBottomChanged"
            :title="T('COMPONENT.widget.bottom')"
            v-show="_checkWidgetInput(target.isAlignBottom, multi)"
          ></ui-input>
        </div>
      </div>

      <div id="lower" class="layout vertical">
        <div class="centered-prop layout horizontal center">
          <ui-checkbox
            v-value="target.isAlignHorizontalCenter.value"
            v-values="target.isAlignHorizontalCenter.values"
            :multi-values="_checkWidgetMulti(target.isAlignHorizontalCenter)"
            @change="_onHorizontalCenterChecked"
            :title="T('COMPONENT.widget.align_h_center')"
          >Horizontal Center</ui-checkbox>
          <span class="flex-1"></span>
          <ui-input
            :value="horizontalCenterValue"
            v-values="horizontalCenterValues"
            :multi-values="_checkWidgetMulti(target.isAlignHorizontalCenter) && _checkWidgetMulti(horizontalCenterValues)"
            @confirm="_onHorizontalCenterChanged"
            :title="T('COMPONENT.widget.horizontal_center')"
            v-show="target.isAlignHorizontalCenter.value === true"
          ></ui-input>
        </div>
        <div class="centered-prop layout horizontal center">
          <ui-checkbox class="v-checkbox"
            v-value="target.isAlignVerticalCenter.value"
            v-values="target.isAlignVerticalCenter.values"
            :multi-values="_checkWidgetMulti(target.isAlignVerticalCenter)"
            @change="_onVerticalCenterChecked"
            :title="T('COMPONENT.widget.align_v_center')"
          >Vertical Center</ui-checkbox>
          <span class="flex-1"></span>
          <ui-input
            :value="verticalCenterValue"
            v-values="horizontalCenterValues"
            :multi-values="_checkWidgetMulti(target.isAlignVerticalCenter) && _checkWidgetMulti(verticalCenterValue)"
            @confirm="_onVerticalCenterChanged"
            :title="T('COMPONENT.widget.vertical_center')"
            v-show="target.isAlignVerticalCenter.value === true"
          ></ui-input>
        </div>
      </div>

      <hr/>
    </div>

    <ui-prop
      v-prop="target.target"
      :multi-values="multi"
    ></ui-prop>
    <ui-prop
      v-prop="target.alignMode"
      :multi-values="multi"
    ></ui-prop>

    `,
    props: {
        target: {
            twoWay: !0,
            type: Object
        },
        multi: {
            type: Boolean
        }
    },
    computed: {
        horizontalCenterValue() {
            return this._compose(this.target.horizontalCenter, this.target.isAbsoluteHorizontalCenter.value)
        },
        horizontalCenterValues() {
            return this.target.isAbsoluteHorizontalCenter.values.map(t=>this._compose(this.target.horizontalCenter, t))
        },
        verticalCenterValue() {
            return this._compose(this.target.verticalCenter, this.target.isAbsoluteVerticalCenter.value)
        },
        topValue() {
            return this._compose(this.target.top, this.target.isAbsoluteTop.value)
        },
        leftValue() {
            return this._compose(this.target.left, this.target.isAbsoluteLeft.value)
        },
        rightValue() {
            return this._compose(this.target.right, this.target.isAbsoluteRight.value)
        },
        bottomValue() {
            return this._compose(this.target.bottom, this.target.isAbsoluteBottom.value)
        }
    },
    methods: {
        T: Editor.T,
        _compose(t, e) {
            var i = t.value
              , n = t.values;
            if (this.multi && n.some(t=>n[0] !== t))
                return "-";
            i = i || 0,
            e || (i *= 100);
            let a = e ? "px" : "%";
            return 0 === i && (i = 0),
            "" + i.toFixed(2) + a
        },
        _decompose(t) {
            let e;
            return t.endsWith("%") || t.endsWith("％") ? (t = t.slice(0, -1),
            e = !1) : (t.endsWith("px") && (t = t.slice(0, -2)),
            e = !0),
            t = "" === t ? 0 : parseFloat(t),
            e || (t /= 100),
            {
                value: t,
                isAbsolute: e
            }
        },
        _changeMargin(t, e, i) {
            if (this.target) {
                let n = this._decompose(t);
                if (isNaN(n.value))
                    return Editor.warn('Invalid input: "%s"', t),
                    !1;
                n.value !== this.target[e].value && (this.target[e].value = n.value),
                n.isAbsolute !== this.target[i].value && (this.target[i].value = n.isAbsolute)
            }
            return !0
        },
        _changePropValue(t, e) {
            Editor.UI.fire(this.$el, "target-change", {
                bubbles: !0,
                detail: {
                    type: t.type,
                    path: t.path,
                    value: t.value
                }
            }),
            Editor.UI.fire(this.$el, "target-change", {
                bubbles: !0,
                detail: {
                    type: e.type,
                    path: e.path,
                    value: e.value
                }
            }),
            Editor.UI.fire(this.$el, "target-confirm", {
                bubbles: !0,
                detail: {
                    type: t.type,
                    path: t.path,
                    value: t.value
                }
            })
        },
        _onHorizontalCenterChanged(t) {
            this._changeMargin(t.detail.value, "horizontalCenter", "isAbsoluteHorizontalCenter"),
            this._changePropValue(this.target.horizontalCenter, this.target.isAbsoluteHorizontalCenter)
        },
        _onVerticalCenterChanged(t) {
            this._changeMargin(t.detail.value, "verticalCenter", "isAbsoluteVerticalCenter"),
            this._changePropValue(this.target.verticalCenter, this.target.isAbsoluteVerticalCenter)
        },
        _onTopChanged(t) {
            this._changeMargin(t.detail.value, "top", "isAbsoluteTop"),
            this._changePropValue(this.target.top, this.target.isAbsoluteTop)
        },
        _onLeftChanged(t) {
            this._changeMargin(t.detail.value, "left", "isAbsoluteLeft"),
            this._changePropValue(this.target.left, this.target.isAbsoluteLeft)
        },
        _onRightChanged(t) {
            this._changeMargin(t.detail.value, "right", "isAbsoluteRight"),
            this._changePropValue(this.target.right, this.target.isAbsoluteRight)
        },
        _onBottomChanged(t) {
            this._changeMargin(t.detail.value, "bottom", "isAbsoluteBottom"),
            this._changePropValue(this.target.bottom, this.target.isAbsoluteBottom)
        },
        _onLeftRightChecked(t) {
            t.detail.value && this.target && this.target.isAlignHorizontalCenter.value && (this.target.isAlignHorizontalCenter.value = !1)
        },
        _onTopBottomChecked(t) {
            t.detail.value && this.target && this.target.isAlignVerticalCenter.value && (this.target.isAlignVerticalCenter.value = !1)
        },
        _onHorizontalCenterChecked(t) {
            t.detail.value && this.target && (this.target.isAlignLeft.value || this.target.isAlignRight.value) && (this.target.isAlignLeft.value = !1,
            this.target.isAlignRight.value = !1)
        },
        _onVerticalCenterChecked(t) {
            t.detail.value && this.target && (this.target.isAlignTop.value || this.target.isAlignBottom.value) && (this.target.isAlignTop.value = !1,
            this.target.isAlignBottom.value = !1)
        },
        _checkWidgetMulti(t) {
            var e = t.values ? t.values : t
              , i = e[0];
            return !e.every(t=>t === i)
        },
        _checkWidgetInput: (t,e)=>e ? t.values.every(t=>!0 === t) : !0 === t.value
    }
});
