"use strict";
Vue.component("cc-mask", {
    template: `
    <ui-prop
        v-prop="target.type"
        :multi-values="multi"
    ></ui-prop>
    <ui-prop
        v-prop="target.inverted"
        :multi-values="multi"
    ></ui-prop>
    <ui-prop min="3"
        v-show="isEllipseType()"
        v-prop="target.segements"
        :multi-values="multi"
    ></ui-prop>
    <ui-prop
        v-show="isImageStencilType()"
        v-prop="target.alphaThreshold"
        :multi-values="multi"
    ></ui-prop>
    <ui-prop
        v-show="isImageStencilType()"
        v-prop="target.spriteFrame"
        :multi-values="multi"
    ></ui-prop>
    <div class="horizontal layout end-justified" style="padding:5px 0;margin-bottom:5px;"
        v-show="target.spriteFrame.value.uuid && isImageStencilType()"
    >
        <ui-button
            v-on:confirm="onAppImageSizeClick"
        >Resize to Target</ui-button>
    <div>
    `,
    props: {
        target: {
            twoWay: !0,
            type: Object
        },
        multi: {
            type: Boolean
        }
    },
    methods: {
        isRectType() {
            return this.target.type.value === cc.Mask.Type.RECT
        },
        isEllipseType() {
            return this.target.type.value === cc.Mask.Type.ELLIPSE
        },
        isImageStencilType() {
            return this.target.type.value === cc.Mask.Type.IMAGE_STENCIL
        },
        onAppImageSizeClick(e) {
            var t = {
                id: this.target.uuid.value,
                path: "_resizeToTarget",
                type: "Boolean",
                isSubProp: !1,
                value: !0
            };
            Editor.Ipc.sendToPanel("scene", "scene:set-property", t)
        }
    }
});
