"use strict";
const t = require("fire-fs")
  , e = require("fire-path")
  , a = require("plist");
Vue.component("cc-particle-system", {
    dependencies: ["packages://inspector/share/blend.js"],
    template: `

    <ui-prop
      v-prop="target.preview"
      :multi-values="multi"
    ></ui-prop>
    <ui-prop
      v-prop="target.playOnLoad"
      :multi-values="multi"
      tooltip="{{T('COMPONENT.particle_system.playOnLoad')}}"
    ></ui-prop>
    <ui-prop
      v-prop="target.autoRemoveOnFinish"
      :multi-values="multi"
    ></ui-prop>
    <ui-prop
      v-prop="target.file"
      :multi-values="multi"
    ></ui-prop>

    <ui-prop name="Custom" tooltip="{{T('COMPONENT.particle_system.custom')}}">
        <ui-checkbox class="flex-1"
          v-value="target.custom.value"
          v-values="target.custom.values"
          :multi-values="_checkCustomMulti(target.custom, multi)"
          @change="onCustomChange"
        >
        </ui-checkbox>
        <ui-button v-show="target.custom.value && target.file.value.uuid"
          :title="T('COMPONENT.particle.sync_tips')"
          v-disabled="multi"
          @confirm="applyPlistData"
        >
          {{T('COMPONENT.particle.sync')}}
        </ui-button>
        <ui-button v-show="target.custom.value"
          :title="T('COMPONENT.particle.export_title')"
          v-disabled="multi"
          @confirm="saveCustomData"
        >
          {{T('COMPONENT.particle.export')}}
        </ui-button>
    </ui-prop>

    <template v-if="_checkCustomShow(target.custom, multi)">
      <ui-prop
        v-prop="target.spriteFrame"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.spriteFrame')}}"
      ></ui-prop>
      <ui-prop
        v-prop="target.duration"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.duration')}}"
      ></ui-prop>
      <ui-prop
        v-prop="target.emissionRate"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.emissionRate')}}"
      ></ui-prop>
      <ui-prop
        :name="target.life.name"
        tooltip="{{T('COMPONENT.particle_system.life')}}"
      >
        <ui-num-input class="flex-1"
          v-value="target.life.value"
          v-values="target.life.values"
          :multi-values="_updateMultiValues(target.life, multi)"
        ></ui-num-input>
        <ui-num-input class="flex-1"
          v-value="target.lifeVar.value"
          v-values="target.lifeVar.values"
          :multi-values="_updateMultiValues(target.lifeVar, multi)"
        ></ui-num-input>
      </ui-prop>
      <ui-prop
        v-prop="target.totalParticles"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.totalParticles')}}"
      ></ui-prop>
      <ui-prop
        v-prop="target.startColor"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.startColor')}}"
      ></ui-prop>
      <ui-prop indent=1
        v-prop="target.startColorVar"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.startColorVar')}}"
      ></ui-prop>
      <ui-prop
        v-prop="target.endColor"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.endColor')}}"
      ></ui-prop>
      <ui-prop indent=1
        v-prop="target.endColorVar"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.endColorVar')}}"
      ></ui-prop>

      <ui-prop
        :name="target.angle.name"
        tooltip="{{T('COMPONENT.particle_system.angle')}}"
      >
        <ui-num-input class="flex-1"
          v-value="target.angle.value"
          v-values="target.angle.values"
          :multi-values="_updateMultiValues(target.angle, multi)"
        ></ui-num-input>
        <ui-num-input class="flex-1"
          v-value="target.angleVar.value"
          v-values="target.angleVar.values"
          :multi-values="_updateMultiValues(target.angleVar, multi)"
        ></ui-num-input>
      </ui-prop>

      <ui-prop
        :name="target.startSize.name"
        tooltip="{{T('COMPONENT.particle_system.startSize')}}"
      >
        <ui-num-input class="flex-1"
          v-value="target.startSize.value"
          v-values="target.startSize.values"
          :multi-values="_updateMultiValues(target.startSize, multi)"
        ></ui-num-input>
        <ui-num-input class="flex-1"
          v-value="target.startSizeVar.value"
          v-values="target.startSizeVar.values"
          :multi-values="_updateMultiValues(target.startSizeVar, multi)"
        ></ui-num-input>
      </ui-prop>

      <ui-prop :name="target.endSize.name" tooltip="{{T('COMPONENT.particle_system.endSize')}}">
        <ui-num-input class="flex-1"
          v-value="target.endSize.value"
          v-values="target.endSize.values"
          :multi-values="_updateMultiValues(target.endSize, multi)"
        ></ui-num-input>
        <ui-num-input class="flex-1"
          v-value="target.endSizeVar.value"
          v-values="target.endSizeVar.values"
          :multi-values="_updateMultiValues(target.endSizeVar, multi)"
        ></ui-num-input>
      </ui-prop>

      <ui-prop :name="target.startSpin.name" tooltip="{{T('COMPONENT.particle_system.startSpin')}}">
        <ui-num-input class="flex-1"
          v-value="target.startSpin.value"
          v-values="target.startSpin.values"
          :multi-values="_updateMultiValues(target.startSpin, multi)"
        ></ui-num-input>
        <ui-num-input class="flex-1"
          v-value="target.startSpinVar.value"
          v-values="target.startSpinVar.values"
          :multi-values="_updateMultiValues(target.startSpinVar, multi)"
        ></ui-num-input>
      </ui-prop>

      <ui-prop :name="target.endSpin.name" tooltip="{{T('COMPONENT.particle_system.endSpin')}}">
        <ui-num-input class="flex-1"
          v-value="target.endSpin.value"
          v-values="target.endSpin.values"
          :multi-values="_updateMultiValues(target.endSpin, multi)"
        ></ui-num-input>
        <ui-num-input class="flex-1"
          v-value="target.endSpinVar.value"
          v-values="target.endSpinVar.values"
          :multi-values="_updateMultiValues(target.endSpinVar, multi)"
        ></ui-num-input>
      </ui-prop>

      <ui-prop
        v-prop="target.posVar"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.posVar')}}"
      ></ui-prop>

      <ui-prop
        v-prop="target.positionType"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.positionType')}}"
      ></ui-prop>
      <ui-prop
        v-prop="target.emitterMode"
        :multi-values="multi"
        tooltip="{{T('COMPONENT.particle_system.emitterMode')}}"
      ></ui-prop>

      <div v-if="isGravityMode(target.emitterMode, multi)">
        <ui-prop indent=1
          v-prop="target.gravity"
          tooltip="{{T('COMPONENT.particle_system.gravity')}}"
        ></ui-prop>

        <ui-prop indent=1
          :name="target.speed.name"
          tooltip="{{T('COMPONENT.particle_system.speed')}}"
        >
          <ui-num-input class="flex-1"
            v-value="target.speed.value"
            v-values="target.speed.values"
            :multi-values="_updateMultiValues(target.speed, multi)"
          ></ui-num-input>
          <ui-num-input class="flex-1"
            v-value="target.speedVar.value"
            v-values="target.speedVar.values"
            :multi-values="_updateMultiValues(target.speedVar, multi)"
          ></ui-num-input>
        </ui-prop>

        <ui-prop indent=1
          :name="target.tangentialAccel.name"
          tooltip="{{T('COMPONENT.particle_system.tangentialAccel')}}"
        >
          <ui-num-input class="flex-1"
            v-value="target.tangentialAccel.value"
            v-values="target.tangentialAccel.values"
            :multi-values="_updateMultiValues(target.tangentialAccel, multi)"
          ></ui-num-input>
          <ui-num-input class="flex-1"
            v-value="target.tangentialAccelVar.value"
            v-values="target.tangentialAccelVar.values"
            :multi-values="_updateMultiValues(target.tangentialAccelVar, multi)"
          ></ui-num-input>
        </ui-prop>

        <ui-prop indent=1
          :name="target.radialAccel.name"
          tooltip="{{T('COMPONENT.particle_system.radialAccel')}}"
        >
          <ui-num-input class="flex-1"
            v-value="target.radialAccel.value"
            v-values="target.radialAccel.values"
            :multi-values="_updateMultiValues(target.radialAccel, multi)"
          ></ui-num-input>
          <ui-num-input class="flex-1"
            v-value="target.radialAccelVar.value"
            v-values="target.radialAccelVar.values"
            :multi-values="_updateMultiValues(target.radialAccelVar, multi)"
          ></ui-num-input>
        </ui-prop>

        <ui-prop indent=1
          v-prop="target.rotationIsDir"
          :multi-values="multi"
          tooltip="{{T('COMPONENT.particle_system.rotationIsDir')}}"
        ></ui-prop>
      </div>
      <div v-if="isRadiusMode(target.emitterMode, multi)">
        <ui-prop indent=1
          :name="target.startRadius.name"
          tooltip="{{T('COMPONENT.particle_system.startRadius')}}"
        >
          <ui-num-input class="flex-1"
            v-value="target.startRadius.value"
            v-values="target.startRadius.values"
            :multi-values="_updateMultiValues(target.startRadius, multi)"
          ></ui-num-input>
          <ui-num-input class="flex-1"
            v-value="target.startRadiusVar.value"
            v-values="target.startRadiusVar.values"
            :multi-values="_updateMultiValues(target.startRadiusVar, multi)"
          ></ui-num-input>
        </ui-prop>

        <ui-prop indent=1
          :name="target.endRadius.name"
          tooltip="{{T('COMPONENT.particle_system.endRadius')}}"
        >
          <ui-num-input class="flex-1"
            v-value="target.endRadius.value"
            v-values="target.endRadius.values"
            :multi-values="_updateMultiValues(target.ednRadius, multi)"
          ></ui-num-input>
          <ui-num-input class="flex-1"
            v-value="target.endRadiusVar.value"
            v-values="target.endRadiusVar.values"
            :multi-values="_updateMultiValues(target.endRadiusVar, multi)"
          ></ui-num-input>
        </ui-prop>

        <ui-prop indent=1
          :name="target.rotatePerS.name"
          tooltip="{{T('COMPONENT.particle_system.rotatePerS')}}"
        >
          <ui-num-input class="flex-1"
            v-value="target.rotatePerS.value"
            v-values="target.rotatePerS.values"
            :multi-values="_updateMultiValues(target.rotatePerS, multi)"
          ></ui-num-input>
          <ui-num-input class="flex-1"
            v-value="target.rotatePerSVar.value"
            v-values="target.rotatePerSVar.values"
            :multi-values="_updateMultiValues(target.rotatePerSVar, multi)"
          ></ui-num-input>
        </ui-prop>
      </div>

      <cc-blend-section :target.sync="target"></cc-blend-section>
    </template>

    `,
    props: {
        target: {
            twoWay: !0,
            type: Object
        },
        multi: {
            type: Boolean
        }
    },
    methods: {
        T: Editor.T,
        isGravityMode: (t,e)=>e ? t.values.every(t=>0 === t) : 0 === t.value,
        isRadiusMode: (t,e)=>e ? t.values.every(t=>1 === t) : 1 === t.value,
        onCustomChange(t) {
            Editor.Ipc.sendToPanel("scene", "scene:set-property", {
                id: this.target.uuid.value,
                path: "spriteFrame",
                type: "cc.SpriteFrame",
                value: {
                    uuid: this.target.spriteFrame.value.uuid
                },
                isSubProp: !1
            })
        },
        saveCustomData() {
            Editor.Ipc.sendToPanel("scene", "scene:export-particle-plist", this.target.uuid.value)
        },
        applyPlistData() {
            let e = this.target;
            e.custom.value && cc.assetManager.loadAny(e.file.value.uuid, (n,i)=>{
                if (n)
                    return Editor.error(n),
                    void 0;
                try {
                    let n = a.parse(t.readFileSync(i.nativeUrl, "utf8"));
                    this._applyPlistData(n, e.uuid.value)
                } catch (t) {
                    Editor.error(t)
                }
            }
            )
        },
        _applyPlistData(t, a) {
            let n = {};
            n.totalParticles = t.maxParticles,
            n.angle = t.angle,
            n.angleVar = t.angleVariance,
            n.duration = t.duration,
            n.srcBlendFactor = t.blendFuncSource,
            n.dstBlendFactor = t.blendFuncDestination;
            let i, u = 255 * t.startColorRed, l = 255 * t.startColorGreen, r = 255 * t.startColorBlue, s = 255 * t.startColorAlpha;
            if (n.startColor = new cc.Color(u,l,r,s),
            u = 255 * t.startColorVarianceRed,
            l = 255 * t.startColorVarianceGreen,
            r = 255 * t.startColorVarianceBlue,
            s = 255 * t.startColorVarianceAlpha,
            n.startColorVar = new cc.Color(u,l,r,s),
            u = 255 * t.finishColorRed,
            l = 255 * t.finishColorGreen,
            r = 255 * t.finishColorBlue,
            s = 255 * t.finishColorAlpha,
            n.endColor = new cc.Color(u,l,r,s),
            u = 255 * t.finishColorVarianceRed,
            l = 255 * t.finishColorVarianceGreen,
            r = 255 * t.finishColorVarianceBlue,
            s = 255 * t.finishColorVarianceAlpha,
            n.endColorVar = new cc.Color(u,l,r,s),
            n.startSize = t.startParticleSize,
            n.startSizeVar = t.startParticleSizeVariance,
            n.endSize = t.finishParticleSize,
            n.endSizeVar = t.finishParticleSizeVariance,
            n.posVar = {
                x: t.sourcePositionVariancex,
                y: t.sourcePositionVariancey
            },
            n.startSpin = t.rotationStart,
            n.startSpinVar = t.rotationStartVariance,
            n.endSpin = t.rotationEnd,
            n.endSpinVar = t.rotationEndVariance,
            n.emitterMode = t.emitterType,
            n.gravity = {
                x: t.gravityx,
                y: t.gravityy
            },
            n.speed = t.speed,
            n.speedVar = t.speedVariance,
            n.radialAccel = t.radialAcceleration,
            n.radialAccelVar = t.radialAccelVariance,
            n.tangentialAccel = t.tangentialAcceleration,
            n.tangentialAccelVar = t.tangentialAccelVariance,
            n.startRadius = t.maxRadius,
            n.startRadiusVar = t.maxRadiusVariance,
            n.endRadius = t.minRadius,
            n.endRadiusVar = t.minRadiusVariance,
            n.rotatePerS = t.rotatePerSecond,
            n.rotatePerSVar = t.rotatePerSecondVariance,
            n.rotationIsDir = t.rotationIsDir,
            n.life = t.particleLifespan,
            n.lifeVar = t.particleLifespanVariance,
            t.emissionRate ? n.emissionRate = t.emissionRate : n.emissionRate = Math.min(n.totalParticles / n.life, Number.MAX_VALUE),
            t.spriteFrameUuid)
                i = t.spriteFrameUuid;
            else if (t.textureFileName) {
                let a = this.target.file.value.uuid
                  , n = Editor.assetdb.remote.uuidToFspath(a)
                  , u = e.parse(t.textureFileName)
                  , l = e.join(e.dirname(n), u.name);
                e.extname(l) || (l += ".png");
                let r = e.join(l, u.name);
                (i = Editor.assetdb.remote.fspathToUuid(r)) || Editor.warn('Apply Plist Data Warn: Can not find texture "%s"', l)
            }
            i && Editor.Ipc.sendToPanel("scene", "scene:set-property", {
                id: a,
                path: "spriteFrame",
                type: "cc.SpriteFrame",
                value: {
                    uuid: i
                },
                isSubProp: !1
            }),
            Editor.Ipc.sendToPanel("scene", "scene:set-property", {
                id: this.target.uuid.value,
                path: "",
                type: "cc.ParticleSystem",
                value: n,
                isSubProp: !1
            })
        },
        _checkCustomMulti: (t,e)=>!!e && !t.values.every(t=>!!t),
        _checkCustomShow: (t,e)=>e ? t.values.every(t=>!!t) : !!t.value,
        _updateMultiValues(t, e) {
            if (!e)
                return !1;
            var a = t.values
              , n = a[0];
            return !a.every(t=>t === n)
        }
    }
});
