"use strict";
Vue.component("cc-physics-joint", {
    template: `

    <ui-prop name="Connected Body" style="padding-top: 8px">
      <ui-node class="flex-1"
        type="cc.RigidBody"
        typename="RigidBody"
        v-value="target.connectedBody.value.uuid"
      >
      </ui-node>
      <ui-button
        class="blue tiny"
        @confirm="lastRigidBody"
      >
        Last
      </ui-button>
      <ui-button
        class="blue tiny"
        @confirm="nextRigidBody"
      >
        Next
      </ui-button>
    </ui-prop>
    <template v-for="prop in target">
      <component
        v-if="prop.attrs.visible !== false && prop.name !== 'Connected Body'"
        :is="prop.compType"
        :target.sync="prop"
        :indent="0"
      ></component>
    </template>

    `,
    props: {
        target: {
            twoWay: !0,
            type: Object
        }
    },
    methods: {
        T: Editor.T,
        lastRigidBody() {
            Editor.Ipc.sendToPanel("scene", "scene:choose-last-rigid-body", this.target.uuid.value)
        },
        nextRigidBody() {
            Editor.Ipc.sendToPanel("scene", "scene:choose-next-rigid-body", this.target.uuid.value)
        }
    }
});
var n = {
    dependencies: ["packages://inspector/inspectors/comps/physics/joint.js"],
    template: `
    <cc-physics-joint :target.sync="target"></cc-physics-joint>
    `,
    props: {
        target: {
            twoWay: !0,
            type: Object
        }
    }
};
Vue.component("cc-distance-joint", n),
Vue.component("cc-revolute-joint", n),
Vue.component("cc-motor-joint", n),
Vue.component("cc-prismatic-joint", n),
Vue.component("cc-rope-joint", n),
Vue.component("cc-weld-joint", n),
Vue.component("cc-wheel-joint", n);
