"use strict";
Vue.component("cc-videoplayer", {
    template: `

    <ui-prop
      v-prop="target.resourceType"
      :multi-values="multi"
    ></ui-prop>
    <ui-prop
      v-prop="target.remoteURL"
      v-show="!_isLocal()"
      :multi-values="multi"
    ></ui-prop>
    <ui-prop v-show="_isLocal()"
      type="cc.Asset"
      assetType="asset"
      name="Clip"
      v-value="target.clip.value"
      :multi-values="multi"
    ></ui-prop>
    <ui-prop
      v-prop="target.currentTime"
      :multi-values="multi"
    ></ui-prop>
    <ui-prop name="Volume">
      <ui-slider
        style="margin-left: -9px;width: 100%;"
        v-value="target.volume.value"
        min="0.0"
        max="1.0">
      </ui-slider>
    </ui-prop>
    <ui-prop
      v-prop="target.mute"
      :multi-values="multi"
    ></ui-prop>
    <ui-prop
      v-prop="target.keepAspectRatio"
      :multi-values="multi"
    ></ui-prop>
    <ui-prop
      v-prop="target.isFullscreen"
      :multi-values="multi"
    ></ui-prop>
    <ui-prop
      v-prop="target.stayOnBottom"
      :multi-values="multi"
    ></ui-prop>
    <cc-array-prop :target.sync="target.videoPlayerEvent"></cc-array-prop>

    `,
    props: {
        target: {
            twoWay: !0,
            type: Object
        }
    },
    methods: {
        T: Editor.T,
        _isLocal() {
            return 1 == this.target.resourceType.value
        }
    }
});
