(()=>{
    "use strict";
    return {
        dependencies: [
            "packages://inspector/share/meta-header.js",
            "packages://inspector/share/code-preview.js"
        ],
        style: `
                .shader-title {
                        font-size: 15px;
                        margin-bottom: 5px;
                        font-weight: bold;
                  }
              `,
        template: `
                <cc-meta-header
                  :target="target"
                  icon="unpack://static/icon/assets/shader.png"
                ></cc-meta-header>

                <div class="props flex-1" v-if="!multi">
                  <ui-section>
                    <div class="header shader-title">Effect</div>
                    <cc-code-preview
                      type="glsl"
                      :path="target.__path__"
                    >
                    </cc-code-preview>
                  </ui-section>

                  <div v-for="(index, shader) in compiledShaders">

                    <ui-section style="margin-top: 20px;" folded>
                      <div class="header shader-title">Compiled Pass {{index}} Vertex Shader</div>
                      <cc-code-preview
                        type="glsl"
                        :code="shader.glsl1.vert"
                      >
                      </cc-code-preview>
                    </ui-section>

                    <ui-section folded>
                      <div class="header shader-title">Compiled Pass {{index}} Fragment Shader</div>
                      <cc-code-preview
                        type="glsl"
                        :code="shader.glsl1.frag"
                      >
                      </cc-code-preview>
                    </ui-section>

                  </div>
                </div>

              `,
        computed: {
            compiledShaders() {
                return this.target.compiledShaders
            }
        }
    }
}
)();
