(()=>{
    "use strict";
    const e = require("fire-path")
      , t = Editor.require("packages://inspector/utils/utils")
      , i = require(Editor.url("app://editor/share/build-utils"))
      , r = Editor.Profile.load("global://features.json")
      , o = [];
    return !r.get("huawei-agc") && o.push("huawei-agc"),
    !r.get("link-sure") && o.push("link-sure"),
    r.get("bytedance-minigame") || (o.push("bytedance"),
    o.push("bytedance-subcontext")),
    {
        dependencies: ["packages://inspector/share/meta-header.js", "packages://inspector/share/markdown-preview.js"],
        style: `
              span {
                    color: #ccc;
                    white-space: nowrap;
                    text-overflow: ellipsis;
                    overflow-x: hidden;
                    margin-right: 5px;
              }
            `,
        template: `
              <cc-meta-header
                :target="target"
                icon="unpack://static/icon/assets/folder.png"
              ></cc-meta-header>

              <div class="props flex-1">
                <div class="layout horizontal center">
                  <span class="flex-1">{{ target.__url__ }}</span>
                  <ui-button class="blue tiny" @confirm="explore">
                    <i class="fa fa-folder-open"></i>
                  </ui-button>
                </div>
                <ui-prop
                  name="{{_t('is_bundle')}}"
                  type="boolean" v-if="!isResources"
                  v-value="target.isBundle"
                  v-values="target.multiValues.isBundle"
                  :multi-values="multi"
                ></ui-prop>
                <ui-prop
                  v-if="_isBundle()"
                  v-readonly="isResources"
                  name="{{_t('bundle_name')}}"
                >
                  <ui-input
                      :placeholder="_bundleName(target.__url__)"
                      v-value="target.bundleName"
                      v-values="target.multiValues.bundleName"
                      :multi-values="multi"
                  ></ui-input>
                </ui-prop>

                <ui-prop
                name="{{_t('priority')}}"
                toolTip="{{_t('priority_tooltip')}}"
                v-readonly="isResources"
                type="enum"
                v-if="_isBundle()"
                v-value="curPriority"
                @confirm="_priorityChanged">
                  <option value="1">1</option>
                  <option value="2">2</option>
                  <option value="3">3</option>
                  <option value="4">4</option>
                  <option value="5">5</option>
                  <option value="6">6</option>
                  <option value="7">7</option>
                  <option value="8">8</option>
                  <option value="9">9</option>
                  <option value="10">10</option>
                  <option value="11" v-if="_isInternal()">11</option>
                </ui-prop>
                <ui-prop name="{{_t('target_platform')}}" toolTip="{{_t('target_platform_tooltip')}}"type="enum" v-if="_isBundle()" v-value="curPlatform" @change.stop @confirm.stop="_platformChanged">
                  <option v-for="platform of platforms" v-value="platform">{{_getPlatformName(platform)}}</option>
                </ui-prop>
                <ui-prop name="{{_t('compression_type')}}" toolTip="{{_t('compression_type_tooltip')}}" type="enum" v-if="_isBundle()" v-value="curCompressionType" @confirm="_settingsChanged">
                  <option value="none" title="{{_t('none_tooltip')}}">{{_t('none')}}</option>
                  <option value="default" title="{{_t('default_tooltip')}}">{{_t('default')}}</option>
                  <option value="merge_all_json" title="{{_t('merge_all_json_tooltip')}}">{{_t('merge_all_json')}}</option>
                  <option value="subpackage" v-if="_supportSubpackage()" title="{{_t('subpackage_tooltip')}}">{{_t('subpackage')}}</option>
                  <option value="zip" v-if="_supportZip()" title="{{_t('zip_tooltip')}}">{{_t('zip')}}</option>
                </ui-prop>
                <ui-prop
                  name="${Editor.T("BUILDER.merge_asset.optimize_hot_update")}"
                  tooltip="${Editor.T("BUILDER.merge_asset.optimize_hot_update_tooltip")}"
                  type="boolean" v-if="_isBundle()&&curCompressionType==='default'&&_isNative()"
                  v-value="curOptimizeHotUpdate"
                  @confirm="_settingsChanged"
                ></ui-prop>
                <ui-prop
                  name="${Editor.T("BUILDER.merge_asset.inline_SpriteFrames")}"
                  tooltip="${Editor.T("BUILDER.merge_asset.inline_SpriteFrames_tooltip")}"
                  type="boolean"
                  v-if="_isBundle()&&curCompressionType==='default'"
                  v-value="curInlineSpriteFrames"
                  @confirm="_settingsChanged"
                ></ui-prop>
                <ui-prop
                  name="{{_t('is_remote_bundle')}}"
                  title="{{_t('is_remote_bundle_tooltip')}}"
                  type="boolean"
                  v-readonly="_isRemoteBundleReadonly()"
                  v-if="_supportRemoteBundle()"
                  v-value="curIsRemoteBundle"
                  @confirm="_settingsChanged"
                ></ui-prop>
                <cc-markdown-preview v-if="_isBundle()"
                  :path="_getMarkdownUrl(isResources)">
                </cc-markdown-preview>
              </div>
            `,
        ready() {
            this._targetChanged()
        },
        data: {
            curPriority: 1,
            url: "",
            isResources: !1,
            curCompressionType: "default",
            curPlatform: "web-mobile",
            curOptimizeHotUpdate: !1,
            curInlineSpriteFrames: !1,
            curIsRemoteBundle: !1,
            platforms: ["web-mobile", "web-desktop", "fb-instant-games", "android", "android-instant", "ios", "mac", "win32"].concat(Object.keys(Editor.remote.Builder.simpleBuildTargets)).filter(e=>!o.includes(e))
        },
        watch: {
            target: "_targetChanged"
        },
        methods: {
            _t: e=>Editor.T(`INSPECTOR.folder.${e}`),
            _supportRemoteBundle() {
                return this._isBundle() && i.supportRemote(this.curPlatform)
            },
            _isRemoteBundleReadonly() {
                return this._isNative() && this.isResources || "zip" === this.curCompressionType || "subpackage" === this.curCompressionType
            },
            _updateCurRemoteBundle() {
                this._supportRemoteBundle() ? this._isRemoteBundleReadonly() && (this._isNative() && this.isResources || "subpackage" === this.curCompressionType ? this.curIsRemoteBundle = !1 : "zip" === this.curCompressionType && (this.curIsRemoteBundle = !0)) : this.curIsRemoteBundle = !1
            },
            _isBundle() {
                return this.target.isBundle || this.isResources
            },
            _isNative() {
                return i.isNativePlatform(this.curPlatform)
            },
            _isInternal() {
                return "db://internal/resources" === this.target.__url__
            },
            _supportSubpackage() {
                return i.supportSubpackage(this.curPlatform)
            },
            _supportZip() {
                return i.supportZip(this.curPlatform)
            },
            _priorityChanged() {
                this.target.metas.forEach(e=>{
                    e.priority = this.curPriority
                }
                )
            },
            _platformChanged() {
                this.curCompressionType = this.target.compressionType[this.curPlatform] || "default",
                this.curInlineSpriteFrames = this.target.inlineSpriteFrames[this.curPlatform] || !1,
                this.curOptimizeHotUpdate = this.target.optimizeHotUpdate[this.curPlatform] || !1,
                this.curIsRemoteBundle = this.target.isRemoteBundle[this.curPlatform] || !1
            },
            _settingsChanged() {
                this._updateCurRemoteBundle(),
                this.target.metas.forEach(e=>{
                    e.compressionType[this.curPlatform] = this.curCompressionType,
                    e.optimizeHotUpdate[this.curPlatform] = this.curOptimizeHotUpdate,
                    e.inlineSpriteFrames[this.curPlatform] = this.curInlineSpriteFrames,
                    e.isRemoteBundle[this.curPlatform] = this.curIsRemoteBundle
                }
                )
            },
            _getPlatformName(e) {
                let t = Editor.remote.Builder.simpleBuildTargets;
                return e in t ? t[e].name : Editor.T("BUILDER.platforms." + e) || e
            },
            async _onApply() {
                if (this.isResources)
                    return !0;
                let e = await t.checkDuplicateNameForBuiltinBundle(this.target);
                return e || Editor.Ipc.sendToWins("inspector:bundle-updated"),
                !e
            },
            _bundleName: t=>"db://assets/resources" === t ? "resources" : "db://internal/resources" === t ? "internal" : e.basenameNoExt(t),
            _getMarkdownUrl: e=>e ? Editor.url(Editor.T("MESSAGE.assets.resources_url")) : Editor.url(Editor.T("MESSAGE.assets.bundle_url")),
            _targetChanged() {
                this.target ? (this.url = this.target.__url__,
                this.isResources = "db://assets/resources" === this.url || "db://internal/resources" === this.url,
                this._platformChanged(),
                this.curPriority = this.target.priority,
                "db://assets/resources" === this.url && (this.curPriority = 8)) : (this.url = "",
                this.isResources = !1)
            },
            explore() {
                Editor.assetdb.explore(this.url)
            }
        }
    }
}
)();
