(()=>{
    "use strict";
    return {
        dependencies: ["packages://inspector/share/meta-header.js", "packages://inspector/share/code-preview.js", "packages://inspector/share/markdown-preview.js"],
        template: `
              <cc-meta-header
                :target="target"
                icon="unpack://static/icon/assets/javascript.png"
              ></cc-meta-header>

              <div class="props">
                <ui-prop :name="T('INSPECTOR.javascript.plugin')" type="boolean"
                  v-value="target.isPlugin"
                  v-values="target.multiValues.isPlugin"
                  :multi-values="multi"
                >
                </ui-prop>
                <div v-if="target.isPlugin">
                  <ui-prop indent=1 type="boolean"
                    :name="T('INSPECTOR.javascript.loadPluginInWeb')"
                    v-value="target.loadPluginInWeb"
                    v-values="target.multiValues.loadPluginInWeb"
                    :multi-values="multi"
                  ></ui-prop>
                  <ui-prop indent=1 type="boolean"
                    :name="T('INSPECTOR.javascript.loadPluginInEditor')"
                    v-if="target.loadPluginInWeb"
                    v-value="target.loadPluginInEditor"
                    v-values="target.multiValues.loadPluginInEditor"
                    :multi-values="multi"
                  ></ui-prop>
                  <ui-prop indent=1 type="boolean"
                    :name="T('INSPECTOR.javascript.loadPluginInEditor')"
                    v-if="!target.loadPluginInWeb"
                    v-value="false"
                    v-disabled="true"
                  ></ui-prop>
                  <ui-prop indent=1 type="boolean"
                    :name="T('INSPECTOR.javascript.loadPluginInNative')"
                    v-value="target.loadPluginInNative"
                    v-values="target.multiValues.loadPluginInNative"
                    :multi-values="multi"
                  ></ui-prop>

                  <cc-markdown-preview style="margin-left: 15px"
                    :path="_getMarkdownUrl()"
                    v-if="!multi"
                  >
                  </cc-markdown-preview>
                </div>

                <cc-code-preview
                  :type="target.__assetType__"
                  :path="target.__path__"
                  v-if="!multi"
                >
                </cc-code-preview>
              </div>
            `,
        methods: {
            _getMarkdownUrl: ()=>Editor.url(Editor.T("MESSAGE.assets.plugin_url"))
        }
    }
}
)();
