(()=>{
    "use strict";
    return {
        dependencies: ["packages://inspector/share/meta-header.js"],
        template: `
                <cc-meta-header
                  :target="target"
                  icon="unpack://static/icon/assets/mesh.png"
                ></cc-meta-header>

                <div class="props flex-1">
                  <ui-prop name="verts" type="number"
                    v-value="target.verts"
                    v-values="target.multiValues.verts"
                    :multi-values="multi"
                    readonly
                  ></ui-prop>
                  <ui-prop name="tris" type="number"
                    v-value="target.tris"
                    v-values="target.multiValues.tris"
                    :multi-values="multi"
                    readonly
                  ></ui-prop>
                  <ui-prop name="submeshes" type="number"
                    v-value="target.submeshes"
                    v-values="target.multiValues.submeshes"
                    :multi-values="multi"
                    readonly
                  ></ui-prop>
                  <ui-prop name="minPos" type="cc.Vec3"
                    v-value="target.minPos"
                    v-values="target.multiValues.minPos"
                    :multi-values="multi"
                    readonly
                  ></ui-prop>
                  <ui-prop name="maxPos" type="cc.Vec3" readonly
                    v-value="target.maxPos"
                    v-values="target.multiValues.maxPos"
                    :multi-values="multi"
                  ></ui-prop>

                  <ui-section>
                    <div class="header">Attributes</div>

                    <div style="padding: 10px;border: 1px dashed rgba(255,255,255,0.4);margin-top:10px;">
                      <div v-for="(index, attributes) in target.attributes">
                        <div> Submesh {{index}}</div>
                        <div style="padding: 10px;border: 1px dashed rgba(255,255,255,0.2);">
                          <div v-for="attribute in attributes">
                            {{attribute}}
                          <div>
                        </div>
                      </div>
                    </div>
                  </ui-section>
                </div>
              `
    }
}
)();
