(()=>{
    "use strict";
    return {
        dependencies: ["packages://inspector/share/meta-header.js"],
        template: `
              <cc-meta-header
                :target="target"
                icon="unpack://static/icon/assets/mount.png"
              ></cc-meta-header>

              <div class="props">
                <div class="layout horizontal center">
                  <span class="flex-1">{{ url }}</span>
                  <ui-button class="blue tiny" @confirm="explore">
                    <i class="fa fa-folder-open"></i>
                  </ui-button>
                </div>
              </div>
            `,
        ready() {
            this.target && Editor.assetdb.queryUrlByUuid(this.target.uuid, (e,t)=>{
                this.url = t
            }
            )
        },
        data: {
            url: ""
        },
        methods: {
            explore() {
                Editor.assetdb.explore(this.url)
            }
        }
    }
}
)();
