(()=>{
    "use strict";
    return {
        dependencies: ["packages://inspector/share/meta-header.js", "packages://inspector/share/image-preview.js", "packages://inspector/share/sprite-section.js"],
        template: `
              <cc-meta-header id="header"
                :target="target"
                :icon="iconUrl(target)"
              ></cc-meta-header>

              <div class="props flex-1">
                <cc-sprite-section
                  :target.sync="target"
                  :multi="multi"
                ></cc-sprite-section>
              </div>

              <cc-image-preview v-ref:preview
                v-if="!multi"
                :target="target"
                :uuid="target.rawTextureUuid"
              >
              </cc-image-preview>
            `,
        ready() {},
        methods: {
            resize() {
                this.$refs.preview.resize()
            },
            iconUrl: e=>`thumbnail://${e.rawTextureUuid}?28&ts=` + Date.now()
        }
    }
}
)();
