(()=>{
    "use strict";
    function e(e) {
        return !(e & e - 1 || !e)
    }
    return {
        dependencies: ["packages://inspector/share/meta-header.js", "packages://inspector/share/image-preview.js", "packages://inspector/share/sprite-section.js", "packages://inspector/share/texture-compress-section.js"],
        template: `
              <cc-meta-header
                :target="target"
                :icon="thumbnail()"
              ></cc-meta-header>

              <div class="props flex-1">
                <ui-prop name="Type" type="enum"
                  v-value="target.type"
                  v-values="target.multiValues.type"
                  :multi-values="multi"
                >
                  <option value="raw">Raw</option>
                  <option value="sprite">Sprite</option>
                </ui-prop>

                <ui-prop name="Premultiply Alpha" type="boolean"
                  v-value="target.premultiplyAlpha"
                  v-values="target.multiValues.premultiplyAlpha"
                  :multi-values="multi"
                ></ui-prop>

                <ui-prop name="Wrap Mode" type="enum"
                  v-value="target.wrapMode"
                  v-values="target.multiValues.wrapMode"
                  :multi-values="multi"
                >
                  <option value="clamp">Clamp</option>
                  <option value="repeat">Repeat</option>
                </ui-prop>

                <ui-prop name="Filter Mode" type="enum"
                  v-value="target.filterMode"
                  v-values="target.multiValues.filterMode"
                  :multi-values="multi"
                >
                  <option value="point">Point</option>
                  <option value="bilinear">Bilinear</option>
                  <option value="trilinear">Trilinear</option>
                </ui-prop>

                <ui-prop name="Gen Mipmaps" type="boolean"
                  v-value="target.genMipmaps"
                  v-values="target.multiValues.genMipmaps"
                  :multi-values="multi"
                >
                </ui-prop>

                <ui-prop name="Packable" type="boolean"
                  v-value="target.packable"
                  v-values="target.multiValues.packable"
                  :multi-values="multi"
                >
                </ui-prop>

                <texture-compress v-ref:preview v-if="!multi"
                  :target.sync="target"
                >
                </texture-compress>

                <ui-section v-if="target.type === 'sprite'&&!multi">
                  <div class="header">Sprite</div>
                  <cc-sprite-section
                    :target.sync="target.subMetas[0]"
                    :child="true"
                  ></cc-sprite-section>
                </ui-section>
              </div>

              <cc-image-preview v-ref:preview v-if="!multi"
                :target="target"
                :uuid="target.uuid"
              >
              </cc-image-preview>
            `,
        ready() {},
        watch: {
            "target.wrapMode": function() {
                "repeat" !== this.target.wrapMode || this.isPow2() || Editor.warn(Editor.T("INSPECTOR.texture.repeat_mode_warning"))
            },
            "target.genMipmaps": function() {
                this.target.genMipmaps && !this.isPow2() && Editor.warn(Editor.T("INSPECTOR.texture.gen_mipmaps_warning"))
            }
        },
        methods: {
            isPow2() {
                return e(this.target.width) && e(this.target.height)
            },
            resize() {
                this.$refs.preview.resize()
            },
            thumbnail() {
                return this.target.uuid ? `thumbnail://${this.target.uuid}?32&ts=` + Date.now() : ""
            }
        }
    }
}
)();
