"use strict";
Vue.component("cc-alignment-preview", {
    template: `

    <style>
      .arrow {
            position: absolute;
      }
      .arrow.left {
            left: -2.5px;
            top: -2px;
      }
      .arrow.left:after {
            border: 2.5px solid transparent;
            border-right: 4px solid #ccc;
            position: absolute;
            content: \' \'
      }
      .arrow.right {
            right: 4px;
            top: -2px;
      }
      .arrow.right:before {
            border: 2.5px solid transparent;
            border-left: 4px solid #ccc;
            position: absolute;
            content: \' \'
      }
      .arrow.up {
            top: -3px;
            left: -2px;
      }
      .arrow.up:after {
            border: 2.5px solid transparent;
            border-bottom: 4px solid #ccc;
            position: absolute;
            content: \' \'
      }
      .arrow.down {
            bottom: 4px;
            left: -2px;
      }
      .arrow.down:before {
            border: 2.5px solid transparent;
            border-top: 4px solid #ccc;
            position: absolute;
            content: \' \'
      }

      .h-arrow-line {
            width: 4px;
            margin: 0 4px 0 4px;
            border-top: 1px solid #ccc;
      }
      .v-arrow-line {
            height: 4px;
            margin: 4px 0 4px 0;
            border-left: 1px solid #ccc;
      }
      #left-arrow {
            position: absolute;
            top: 50%;
            left: -13px;
      }
      #right-arrow {
            position: absolute;
            top: 50%;
            right: -13px;
      }
      #top-arrow {
            position: absolute;
            top: -13px;
            left: 50%;
      }
      #bottom-arrow {
            position: absolute;
            left: 50%;
            bottom: -13px;
      }
    </style>

    <div :style="cssContainer">
          <div :style="cssContainerSize"></div>

      <div :style="[cssLine, cssLineH, cssTopLine]" v-show="target.isAlignTop.value"></div>
      <div :style="[cssLine, cssLineV, cssLeftLine]" v-show="target.isAlignLeft.value"></div>
      <div :style="[cssLine, cssLineV, cssRightLine]" v-show="target.isAlignRight.value"></div>
      <div :style="[cssLine, cssLineH, cssBottomLine]" v-show="target.isAlignBottom.value"></div>
      <div :style="[cssLine, cssLineV, cssHCLine]" v-show="target.isAlignHorizontalCenter.value"></div>
      <div :style="[cssLine, cssLineH, cssVCLine]" v-show="target.isAlignVerticalCenter.value"></div>

      <div :style="[cssWidget, _alignStyle()]">
            <div id="left-arrow" v-show="target.isAlignLeft.value">
              <div class="h-arrow-line"></div>
          <div class="arrow left"></div>
          <div class="arrow right"></div>
        </div>
        <div id="right-arrow" v-show="target.isAlignRight.value">
              <div class="h-arrow-line"></div>
          <div class="arrow left"></div>
          <div class="arrow right"></div>
        </div>
        <div id="top-arrow" v-show="target.isAlignTop.value">
              <div class="v-arrow-line"></div>
          <div class="arrow up"></div>
          <div class="arrow down"></div>
        </div>
        <div id="bottom-arrow" v-show="target.isAlignBottom.value">
              <div class="v-arrow-line"></div>
          <div class="arrow up"></div>
          <div class="arrow down"></div>
        </div>
      </div>
    </div>

    `,
    data: ()=>({
        cssContainer: {
            margin: "3px 8px",
            backgroundColor: "#555556",
            border: "1px solid #2a2a2a",
            boxShadow: "0px 0px 4px #333",
            boxSizing: "content-box",
            position: "relative",
            width: "84px",
            height: "84px"
        },
        cssContainerSize: {
            width: "84px",
            height: "84px",
            visibility: "hidden"
        },
        cssWidget: {
            width: "80px",
            height: "80px",
            margin: "20px 20px 20px 20px",
            backgroundColor: "#7d7d7d",
            border: "1px solid #2a2a2a",
            borderRadius: "5px",
            boxSizing: "border-box",
            position: "absolute",
            left: "0",
            top: "0"
        },
        cssLine: {
            border: "dashed 0px #a5a5a5",
            width: "0",
            height: "0",
            position: "absolute"
        },
        cssLineH: {
            width: "84px",
            borderTopWidth: "1px"
        },
        cssLineV: {
            height: "84px",
            borderLeftWidth: "1px"
        },
        cssTopLine: {
            top: "12px",
            left: "0"
        },
        cssLeftLine: {
            left: "12px",
            top: "0"
        },
        cssRightLine: {
            right: "12px",
            top: "0"
        },
        cssBottomLine: {
            bottom: "12px",
            left: "0"
        },
        cssHCLine: {
            top: "0",
            left: "50%",
            zIndex: "1"
        },
        cssVCLine: {
            top: "50%",
            left: "0",
            zIndex: "1"
        }
    }),
    props: {
        target: {
            twoWay: !0,
            type: Object
        }
    },
    methods: {
        T: Editor.T,
        _alignStyle() {
            let n = this.target.isAlignTop.value
              , i = this.target.isAlignLeft.value
              , t = this.target.isAlignRight.value
              , o = this.target.isAlignBottom.value;
            const e = 12
              , s = 84 - e - 42
              , r = 21;
            function a(n, i) {
                return n ? e : i ? s : r
            }
            let d = a(n, o)
              , l = a(o, n)
              , p = a(i, t)
              , v = a(t, i);
            return {
                width: `${84 - p - v}px`,
                height: `${84 - d - l}px`,
                marginRight: `${v}px`,
                marginLeft: `${p}px`,
                marginTop: `${d}px`,
                marginBottom: `${l}px`
            }
        }
    }
});
