"use strict";
Vue.component("cc-array-prop", {
    template: `

    <ui-prop
      :tooltip="target.attrs.tooltip"
      :name="target.name"
      :indent="indent"
      v-readonly="target.attrs.readonly"
      foldable
    >
      <template v-if="!target.values || target.values.length <= 1">
        <ui-num-input class="flex-1"
          type="int" min="0"
          :value="target.value.length"
          @confirm="arraySizeChanged"
          droppable="node,asset"
          :resourcetype="getType()"
          :elementtype="target.elementType"
          :attrtype="target.attrs.type"
          multi
        ></ui-num-input>
        <div class="child">
          <component
            v-for="prop in target.value"
            :is="prop.compType"
            :target.sync="prop"
            :indent="indent+1"
          ></component>
        </div>
      </template>
      <template v-else>
        <span>Difference</span>
      </template>
    </ui-prop>

    `,
    props: {
        indent: {
            type: Number,
            default: 0
        },
        target: {
            twoWay: !0,
            type: Object
        }
    },
    methods: {
        getType() {
            return "cc.Node" === this.target.elementType ? this.target.attrs.type : Editor.assettype2name[this.target.attrs.type]
        },
        arraySizeChanged(e) {
            let t = e.detail.dragItems;
            if (t && setTimeout(()=>{
                for (let e = this.$children.length; e > 0; e--) {
                    let n = this.$children[e - 1].$el.children[0]
                      , a = this.$children.length - e;
                    if ("" !== n.value || a >= t.length)
                        break;
                    n.updateValue(t[t.length - a - 1].id)
                }
            }
            , 400),
            e.detail.value < this.target.value.length) {
                let t = new Array(e.detail.value);
                for (let n = 0; n < e.detail.value; ++n)
                    t[n] = this.target.value[n];
                this.target.value = t
            } else
                this.target.value.length = e.detail.value;
            Editor.UI.fire(this.$el, "target-size-change", {
                bubbles: !0,
                detail: {
                    path: this.target.path + ".length",
                    value: e.detail.value
                }
            })
        }
    }
});
