"use strict";
const e = require("highlight.js")
  , {lineNumbersBlock: n} = Editor.require("packages://inspector/utils/highlightjs-line-numbers");
Vue.component("cc-code-preview", {
    template: `

    <div class="code-preview">
      <style type="text/css">
        @import url('packages://inspector/share/code-preview.tomorrow-night-eighties.css');

        .code-preview {
            display: flex;
            overflow: hidden;
        }

        pre.code {
          position: relative;
          overflow: auto;

          border: 1px solid #212121;
          background: #333;

          margin: 0px;
          padding: 10px;
          font-size: 12px;
          font-family: Consolas, "Liberation Mono", Menlo, Courier, monospace;

          -webkit-user-select: text;
          cursor: auto;
        }

        pre.code::selection {
          background: #007acc;
        }

        pre.code * {
          -webkit-user-select: text;
        }

        pre.code *::selection {
          background: #007acc;
        }

        /* highlightjs-line-numbers */
        .hljs-ln td.hljs-ln-numbers {
            user-select: none;

            text-align: center;
            color: rgba(232, 206, 206, 0.3);
            border-right: 2px solid rgba(232, 206, 206, 0.3);
            vertical-align: top;
            padding-right: 5px;
        }
        .hljs-ln td.hljs-ln-code {
            padding-left: 10px;
        }
        .hljs-ln{
          border-collapse:collapse
        }
        .hljs-ln td{
          padding:0
        }
        .hljs-ln-n:before{
          content:attr(data-line-number)
        }
      </style>
      <pre v-el:code class="code flex-1"></pre>
    </div>

    `,
    props: {
        type: String,
        path: String,
        code: String
    },
    watch: {
        path: "_updateText",
        type: "_updateText",
        code: "_showCode"
    },
    compiled() {
        this._updateText()
    },
    methods: {
        _updateText() {
            (this.path || this.code) && "unknown" !== this.type && (this.code && !this.path ? this._showCode() : this._highlightCode())
        },
        _highlightCode() {
            const e = require("fire-fs")
              , n = require("event-stream");
            let t = e.createReadStream(this.path, {
                encoding: "utf-8"
            })
              , i = 400
              , o = ""
              , s = t.pipe(n.split()).pipe(n.mapSync(e=>{
                o += e + "\n",
                --i <= 0 && (o += "...\n",
                t.close(),
                s.push(null),
                s.end())
            }
            )).on("close", function(e) {
                if (e)
                    throw e;
                this.code = o
            }
            .bind(this))
        },
        _showCode() {
            let t = this.$els.code;
            if (!t)
                return;
            let i = this.code;
            if ("text" !== this.type) {
                let o = e.highlight(this.type, i);
                t.innerHTML = o.value,
                n(t)
            } else
                t.innerHTML = i
        }
    }
});
