"use strict";
Vue.component("cc-comp-section", {
    template: `
    <ui-section>
      <div class="header flex-1 layout horizontal center-center">
        <ui-checkbox hidden="{{!editor._showTick}}"
          v-value="target.enabled.value"
          v-values="target.enabled.valuse"
          :multi-values="_updateEnabelMulti(target.enabled)"
        ></ui-checkbox>
        {{name}}
        <span class="flex-1"></span>
        <ui-button class="tiny transparent"
          title="{{T('INSPECTOR.component.help')}}"
          hidden="{{!editor.help}}"
          @click="openHelpClick"
          >
          <i class="fa fa-book"></i>
        </ui-button>
        <ui-button v-el:dropdown class="tiny transparent"
          title=""
          @click="menuClick"
          >
          <i class="fa fa-cog"></i>
        </ui-button>
      </div>

      <template v-if="!customDraw()">
        <template v-for="prop in target">
          <component
            v-if="prop.attrs.visible !== false"
            :is="prop.compType"
            :target.sync="prop"
            :indent="0"
            :multi-values="multi"
          ></component>
        </template>
      </template>
    </ui-section>
    `,
    props: {
        name: {
            twoWay: !0,
            type: String
        },
        editor: {
            twoWay: !0,
            type: Object
        },
        target: {
            twoWay: !0,
            type: Object
        },
        index: {
            type: Number
        },
        count: {
            type: Number
        },
        multi: {
            type: Boolean
        }
    },
    methods: {
        T: Editor.T,
        customDraw() {
            return this.editor && this.editor.inspector
        },
        menuClick(e) {
            e.stopPropagation(),
            this._requestID && (Editor.Ipc.cancelRequest(this._requestID),
            this._requestID = null),
            this._requestID = Editor.Ipc.sendToPanel("scene", "scene:has-copied-component", (e,t)=>{
                let n = this.$els.dropdown.getBoundingClientRect()
                  , i = this.target.node.values.map(e=>e.uuid) || []
                  , o = this.target.uuid.values;
                Editor.Ipc.sendToPackage("inspector", "popup-component-inspector-menu", {
                    nodeUuids: i,
                    compUuids: o,
                    hasCopyComp: t,
                    multi: this.multi,
                    compIndex: this.index,
                    compCount: this.count,
                    x: n.left,
                    y: n.bottom + 5
                })
            }
            , -1)
        },
        openHelpClick(e) {
            e.stopPropagation();
            let t = this.editor.help;
            t.startsWith("i18n:") && (t = Editor.T(t.replace("i18n:", ""))),
            require("electron").shell.openExternal(t)
        },
        _updateEnabelMulti(e) {
            var t = e.values
              , n = t[0];
            return !t.every(e=>e == n)
        }
    },
    compiled() {
        this.customDraw() && Editor.import(this.editor.inspector).then(e=>{
            if (!e || "function" != typeof e)
                return Editor.warn(`Failed to load inspector ${this.editor.inspector} for component "${this.name}"`),
                void 0;
            function t() {
                let t = document.createElement("div");
                this.$el.appendChild(t),
                new e({
                    el: t,
                    propsData: {
                        target: this.target,
                        multi: this.multi
                    }
                })
            }
            e.options && e.options.dependencies && e.options.dependencies.length ? Editor.import(e.options.dependencies).then(()=>{
                t.call(this)
            }
            ) : t.call(this)
        }
        )
    }
});
