"use strict";
Vue.component("cc-event-prop", {
    template: `

    <ui-prop
      :name="target.name"
      :indent="indent"
      :tooltip="target.attrs.tooltip"
      style="padding-top: 8px;"
      auto-height
    >
      <div class="layout vertical flex-1">
        <div class="layout horizontal">
          <ui-node class="flex-1" v-value="target.value.target.value.uuid"></ui-node>
          <ui-select class="flex-1" v-value="target.value._componentName.value">
            <option v-for="item in components" :value="item">
              {{item}}
            </option>
          </ui-select>
          <ui-select class="flex-1" v-value="target.value.handler.value">
            <option v-for="item in handlers" :value="item">
              {{item}}
            </option>
          </ui-select>
        </div>
        <div class="layout horizontal" style="padding-top: 8px;">
          <div class="label" style="white-space:nowrap;padding-right:10px;padding-top:2px;">
          CustomEventData
          </div>
          <ui-input class="flex-1" v-value="target.value.customEventData.value"></ui-input>
        </div>
    </div>
    </ui-prop>

    `,
    props: {
        indent: {
            type: Number,
            default: 0
        },
        target: {
            twoWay: !0,
            type: Object
        }
    },
    data: ()=>({
        components: [],
        handlers: []
    }),
    watch: {
        "target.value.target.value.uuid": "_updateDump",
        "target.value._componentName.value": "_updateHandlers"
    },
    compiled() {
        this._updateDump()
    },
    methods: {
        _updateDump() {
            this._requestID && (Editor.Ipc.cancelRequest(this._requestID),
            this._requestID = null),
            this._dump = null;
            let e = this.target.value.target.value.uuid;
            this._requestID = Editor.Ipc.sendToPanel("scene", "scene:query-node-functions", e, (e,t)=>{
                this._dump = t,
                this._requestID = null,
                this._updateComponents(),
                this._updateHandlers()
            }
            , -1)
        },
        _updateComponents() {
            if (!this._dump)
                return this.components = [],
                void 0;
            this.components = Object.keys(this._dump)
        },
        _updateHandlers() {
            if (!this._dump)
                return this.handlers = [],
                void 0;
            let e = this._dump[this.target.value._componentName.value];
            e && e.sort(function(e, t) {
                return e.localeCompare(t)
            }),
            this.handlers = e || []
        }
    }
});
