"use strict";
Vue.component("cc-meta-header", {
    style: `
        .pixelated {
            image-rendering: pixelated;
        }
    `,
    template: `
    <div :style="cssHost">
        <img :style="cssIcon" :class="{ pixelated: pixelated }"
        :src="icon"
        />
        <div :style="cssTitle">{{ target.__name__ }}</div>

        <span class="flex-1"></span>

        <ui-button class="red"
        v-disabled="!target.__dirty__"
        @confirm="revert"
        >
        ${Editor.T("MESSAGE.revert")}
        </ui-button>
        <ui-button :style="btnMargin" class="green"
        v-disabled="!target.__dirty__"
        @confirm="apply"
        >
        ${Editor.T("MESSAGE.apply")}
        </ui-button>
    </div>

    `,
    data() {
        return {
            cssHost: {
                display: "flex",
                flex: "none",
                flexDirection: "row",
                alignItems: "center",
                paddingBottom: "2px",
                margin: "5px 10px",
                marginBottom: "10px",
                borderBottom: "1px solid #666",
                height: "35px",
                overflow: "hidden"
            },
            cssIcon: {
                marginRight: "5px"
            },
            cssTitle: {
                fontWeight: "bold",
                textOverflow: "ellipsis",
                overflow: "hidden"
            },
            btnMargin: {
                marginLeft: "10px"
            },
            pixelated: this.icon && this.icon.startsWith("unpack://")
        }
    },
    props: {
        icon: String,
        target: Object
    },
    methods: {
        revert() {
            Editor.UI.fire(this.$el, "meta-revert")
        },
        apply() {
            Editor.UI.fire(this.$el, "meta-apply", {
                detail: {
                    target: this.target
                }
            })
        }
    }
});
