"use strict";
Vue.component("cc-null-prop", {
    template: `
    <ui-prop
      :name="target.name"
      :indent="indent"
      style="padding-top: 8px;"
    >
      <div :style="cssWrapper">Null</div>
      <div :style="[cssWrapper, cssType]">{{target.attrs.typename}}</div>
      <span class="flex-1"></span>
      <ui-button class="tiny blue" @confirm="_applyAction">{{action}}</ui-button>
    </ui-prop>

    `,
    data: ()=>({
        cssWrapper: {
            marginRight: "5px",
            padding: "1px 6px",
            borderRadius: "3px",
            fontWeight: "bold",
            textOverflow: "ellipsis",
            overflow: "hidden",
            whitespace: "nowrap",
            minWidth: "20px",
            background: "#aaa",
            color: "#333"
        },
        cssType: {
            color: "#000",
            background: "#1fa135"
        },
        action: "Create"
    }),
    watch: {
        "target.attrs.type": "_updateAction"
    },
    props: {
        indent: {
            type: Number,
            default: 0
        },
        target: {
            twoWay: !0,
            type: Object
        }
    },
    methods: {
        _updateAction() {
            let t = this.target.attrs.type;
            this.action = "String" === t || "Enum" === t || "Boolean" === t || "Float" === t || "Integer" === t ? "Reset" : "Create"
        },
        _applyAction() {
            "Create" === this.action ? Editor.UI.fire(this.$el, "new-prop", {
                bubbles: !0,
                detail: {
                    path: this.target.path,
                    type: this.target.attrs.type
                }
            }) : Editor.UI.fire(this.$el, "reset-prop", {
                bubbles: !0,
                detail: {
                    path: this.target.path,
                    type: this.target.attrs.type
                }
            })
        }
    },
    compiled() {
        this._updateAction()
    }
});
