"use strict";
const e = Editor.require("packages://inspector/utils/utils").syncObjectProperty;
Vue.component("cc-object-prop", {
    template:
    `
    <ui-prop
      :tooltip="target.attrs.tooltip"
      :name="target.name"
      :indent="indent"
      v-readonly="target.attrs.readonly"
      foldable
    >
      <ui-checkbox class="flex-1"
          v-if="target.value.enable && (target.value.enable.type === 'Boolean' || target.value.enable.type === 'boolean')"
          v-value="target.value.enable.value"
          v-values="target.value.enable.values"
          @change="_enabledChanged($event)"
      ></ui-checkbox>

      <div class="child" v-if="target.value.enable && (target.value.enable.type === 'Boolean' || target.value.enable.type === 'boolean')" >
        <template v-for="prop in target.value">
          <component
            v-if="target.value.enable.value && prop.attrs.visible !== false"
            :is="prop.compType"
            :target.sync="prop"
            :indent="indent+1"
          ></component>
        </template>
      </div>

      <div class="child" v-else>
        <template v-for="prop in target.value">
            <component
            v-if="prop.attrs.visible !== false"
            :is="prop.compType"
            :target.sync="prop"
            :indent="indent+1"
          ></component>
        </template>
      </div>
    </ui-prop>
` ,
    props: {
        indent: {
            type: Number,
            default: 0
        },
        target: {
            twoWay: !0,
            type: Object
        }
    },
    methods: {
        _enabledChanged(t) {
            this.target.value.enable.value = t.detail.value,
            e(this.$root, this.target.value.enable.path, "Boolean", t.detail.value)
        }
    }
});
