"use strict";
const e = Editor.require("packages://inspector/utils/utils").syncObjectProperty;
Vue.component("cc-shape-module", {
    template: `

    <ui-prop
      :tooltip="target.attrs.tooltip"
      :name="target.name"
      :indent="indent"
      :target="target"
      v-readonly="target.attrs.readonly"
      foldable
    >
        <ui-checkbox class="flex-1"
            v-if="target.value.enable && (target.value.enable.type === 'Boolean' || target.value.enable.type === 'boolean')"
            v-value="target.value.enable.value"
            v-values="target.value.enable.values"
            @change="_enabledChanged($event)"
        ></ui-checkbox>

        <div class="child" v-if="target.value.enable.value" >
            <component
                v-if="target.value.enable.attrs.visible !== false"
                :is="target.value.enable.compType"
                :target.sync="target.value.enable"
                :indent="indent+1"
            ></component>

            <component
                v-if="target.value.shapeType.attrs.visible !== false"
                :is="target.value.shapeType.compType"
                :target.sync="target.value.shapeType"
                :indent="indent+1"
            ></component>

            <ui-prop
                v-if="checkEnumInSubset(target.value.shapeType, ['Box','Cone','Sphere','Hemisphere'])"
                :name="target.value.emitFrom.name"
                :indent="indent+1"
            >
                <ui-select
                    :value="target.value.emitFrom.value"
                    @confirm="_onChangeEmit"
                >
                    <option
                        v-for="item in getShapeTypeEmitFrom(target.value.shapeType.value)"
                        :value='item.value'>
                        {{item.name}}
                    </option>
                </ui-select>
            </ui-prop>

            <component v-if="checkEnumInSubset(target.value.shapeType, ['Circle','Cone','Sphere','Hemisphere'])"
                :is="target.value.radius.compType"
                :target.sync="target.value.radius"
                :indent="indent+1"
            ></component>

            <component v-if="checkEnumInSubset(target.value.shapeType, ['Circle','Cone','Sphere','Hemisphere'])"
                :is="target.value.radiusThickness.compType"
                :target.sync="target.value.radiusThickness"
                :indent="indent+1"
            ></component>

            <component v-if="checkEnumInSubset(target.value.shapeType, ['Cone'])"
                :is="target.value.angle.compType"
                :target.sync="target.value.angle"
                :indent="indent+1"
            ></component>

            <component v-if="checkEnumInSubset(target.value.shapeType, ['Circle','Cone','Sphere','Hemisphere'])"
                :is="target.value.arc.compType"
                :target.sync="target.value.arc"
                :indent="indent+1"
            ></component>

            <component v-if="checkEnumInSubset(target.value.shapeType, ['Circle','Cone','Sphere','Hemisphere'])"
                :is="target.value.arcMode.compType"
                :target.sync="target.value.arcMode"
                :indent="indent+1"
            ></component>

            <component v-if="checkEnumInSubset(target.value.shapeType, ['Circle','Cone','Sphere','Hemisphere'])"
                :is="target.value.arcSpread.compType"
                :target.sync="target.value.arcSpread"
                :indent="indent+1"
            ></component>

            <component v-if="checkEnumInSubset(target.value.shapeType, ['Circle','Cone','Sphere','Hemisphere'])"
                :is="target.value.arcSpeed.compType"
                :target.sync="target.value.arcSpeed"
                :indent="indent+1"
            ></component>

            <component v-if="checkEnumInSubset(target.value.shapeType, ['Cone'])"
                :is="target.value.length.compType"
                :target.sync="target.value.length"
                :indent="indent+1"
            ></component>

            <component v-if="checkEnumInSubset(target.value.shapeType, ['Box'])"
                :is="target.value.boxThickness.compType"
                :target.sync="target.value.boxThickness"
                :indent="indent+1"
            ></component>

            <component v-if="target.value.position.attrs.visible !== false"
                :is="target.value.position.compType"
                :target.sync="target.value.position"
                :indent="indent+1"
            ></component>

            <component v-if="target.value.rotation.attrs.visible !== false"
                :is="target.value.rotation.compType"
                :target.sync="target.value.rotation"
                :indent="indent+1"
            ></component>

            <component v-if="target.value.scale.attrs.visible !== false"
                :is="target.value.scale.compType"
                :target.sync="target.value.scale"
                :indent="indent+1"
            ></component>

            <component v-if="target.value.alignToDirection.attrs.visible !== false"
                :is="target.value.alignToDirection.compType"
                :target.sync="target.value.alignToDirection"
                :indent="indent+1"
            ></component>

            <component v-if="target.value.randomDirectionAmount.attrs.visible !== false"
                :is="target.value.randomDirectionAmount.compType"
                :target.sync="target.value.randomDirectionAmount"
                :indent="indent+1"
            ></component>

            <component v-if="target.value.sphericalDirectionAmount.attrs.visible !== false"
                :is="target.value.sphericalDirectionAmount.compType"
                :target.sync="target.value.sphericalDirectionAmount"
                :indent="indent+1"
            ></component>

            <component v-if="target.value.randomPositionAmount.attrs.visible !== false"
                :is="target.value.randomPositionAmount.compType"
                :target.sync="target.value.randomPositionAmount"
                :indent="indent+1"
            ></component>
        </div>
    </ui-prop>

    `,
    props: {
        indent: {
            type: Number,
            default: 0
        },
        target: {
            twoWay: !0,
            type: Object
        }
    },
    methods: {
        _enabledChanged(n) {
            this.target.value.enable.value = n.detail.value,
            e(this.$root, this.target.value.enable.path, "Boolean", n.detail.value)
        },
        getEnumObjFromName(e, n) {
            const t = {};
            for (const n of e.attrs.enumList)
                t[n.name] = {
                    name: n.name,
                    value: parseInt(n.value)
                };
            return n.map(e=>t[e])
        },
        getShapeTypeEmitFrom(e) {
            const n = this;
            let t = null;
            switch (this.getEnumName(n.target.value.shapeType, e)) {
            case "Box":
                t = this.getEnumObjFromName(n.target.value.emitFrom, ["Volume", "Shell", "Edge"]);
                break;
            case "Cone":
                t = this.getEnumObjFromName(n.target.value.emitFrom, ["Base", "Shell", "Volume"]);
                break;
            case "Sphere":
            case "Hemisphere":
                t = this.getEnumObjFromName(n.target.value.emitFrom, ["Volume", "Shell"]);
                break;
            default:
                t = []
            }
            return t
        },
        getEnumName(e, n) {
            for (const t of e.attrs.enumList)
                if (t.value === n)
                    return t.name;
            return String()
        },
        checkEnumInSubset(e, n) {
            const t = this.getEnumName(e, e.value);
            for (const e of n)
                if (e === t)
                    return !0;
            return !1
        },
        _onChangeEmit(n) {
            e(this.$root, this.target.value.emitFrom.path, "Enum", parseInt(n.detail.value))
        }
    }
});
