"use strict";
Vue.component("cc-type-error-prop", {
    template: `
    <ui-prop
      :name="target.name"
      :indent="indent"
      style="padding-top: 8px;"
    >
      <div :style="cssWrapper">Type Error</div>
      <span class="flex-1"></span>
      <ui-button class="tiny blue" @confirm="_onReset">Reset</ui-button>
    </ui-prop>
    `,
    data: ()=>({
        cssWrapper: {
            marginRight: "5px",
            padding: "1px 6px",
            borderRadius: "3px",
            fontWeight: "bold",
            textOverflow: "ellipsis",
            overflow: "hidden",
            whitespace: "nowrap",
            minWidth: "20px",
            background: "#900",
            color: "#aaa"
        },
        cssType: {
            color: "#000",
            background: "#1fa135"
        }
    }),
    props: {
        indent: {
            type: Number,
            default: 0
        },
        target: {
            twoWay: !0,
            type: Object
        }
    },
    methods: {
        _onReset() {
            Editor.UI.fire(this.$el, "reset-prop", {
                bubbles: !0,
                detail: {
                    path: this.target.path,
                    type: this.target.attrs.type
                }
            })
        }
    }
});
